Subject: Re: [PATCH] builtins + test helpers: use return instead of exit() in cmd_*

From: Ævar Arnfjörð Bjarmason <[email-masked]>
Date: Tue, 08 Jun 2021 12:53:52 +0200

On Tue, Jun 08 2021, Jeff King wrote:

> On Mon, Jun 07, 2021 at 01:12:48PM +0200, Ævar Arnfjörð Bjarmason wrote:
>
>> Change various cmd_* functions to use "return" instead of exit() to
>> indicate an exit code. On Solaris with SunCC the compiler legitimately
>> complains about these, since we'll e.g. skip the cleanup (e.g. closing
>> fd's, erroring if we can't) in git.c's run_builtin() when we exit()
>> directly like this.
>
> Each of these cases looks like a simple and obvious conversion, and I
> certainly don't mind us doing it.
>
> But I do wonder what SunCC is complaining about exactly. Calling exit()
> means you don't have to worry about cleanup anymore. Does the compiler
> not have any notion of NORETURN or equivalent? If so, I'd expect many
> more complaints in general that we probably _won't_ want to silence,
> because it will be awkward to do so.

It does, but in this case there's no NORETURN and we declared the
command to return int, and it's not the "main" function.

I believe that's what trips it up, as noted in a v2 I just submitted
now:
https://lore.kernel.org/git/[email-masked]/

It's not whining about every instance of "exit" in the codebase.

>> diff --git a/builtin/difftool.c b/builtin/difftool.c
>> index 89334b77fb..6a9242a803 100644
>> --- a/builtin/difftool.c
>> +++ b/builtin/difftool.c
>> @@ -675,7 +675,7 @@ static int run_file_diff(int prompt, const char *prefix,
>>  		"GIT_PAGER=", "GIT_EXTERNAL_DIFF=git-difftool--helper", NULL,
>>  		NULL
>>  	};
>> -	int ret = 0, i;
>> +	int i;
>>  
>>  	if (prompt > 0)
>>  		env[2] = "GIT_DIFFTOOL_PROMPT=true";
>> @@ -686,8 +686,7 @@ static int run_file_diff(int prompt, const char *prefix,
>>  	strvec_push(&args, "diff");
>>  	for (i = 0; i < argc; i++)
>>  		strvec_push(&args, argv[i]);
>> -	ret = run_command_v_opt_cd_env(args.v, RUN_GIT_CMD, prefix, env);
>> -	exit(ret);
>> +	return run_command_v_opt_cd_env(args.v, RUN_GIT_CMD, prefix, env);
>>  }
>
> This one I'm not surprised that a compiler would complain about. The
> function returns an int, but there are no return paths from the
> function (and hence the caller doing "return run_diff_files()" likewise
> could not ever return there. Which is not quite what you said it
> complained about above, hence my curiosity. :)

I sent a few miscellaneous fixes recently for 15-20 SunCC
warnings. Around 1/2 of these are legitimate issues like these, the rest
are bugs in SunCC or flaws in it flow analysis or other known bugs in
the compiler.